#! /bin/csh -f
# Generate Nemo Manual Pages HTML Document
#	Note: doesn't work under Solaris
#	Sunos makes this:
#<a href=man_html/anisot.1.html>anisot</a>           <a href=man_html/atos.1.html>atos</a>             <a href=man_html/atosph.1.html>atosph</a>           <a href=man_html/badman.1.html>badman</a>           <a href=man_html/badnews.1.html>badnews</a>        
#	and Solaris this:
#<a href=man_html/anisot.1.html>anisot</<a href=man_html/atos.1.html>atos</a>  <a href=man_html/atosph.1.html>atosph</<a href=man_html/badman.1.html>badman</<a href=man_html/badnews.1.html>badnews

if ($#argv == 0) then
  set sec=1
else
  set sec=$1
endif
set cat=cat$sec

echo "<HTML>"
echo "<HEAD>"
echo "<TITLE>NEMO Manual Pages </TITLE>"
echo "</HEAD>"
echo "<BODY>"
echo "<\!-- do not edit this file; created by $0 -->"
echo "<CENTER>"
echo -n "[<A HREF=index1.html>man1</A>,"
echo -n "<A HREF=index3.html>man3</A>,"
echo -n "<A HREF=index5.html>man5</A>,"
echo -n "<A HREF=index6.html>man6</A>,"
echo -n "<A HREF=index8.html>man8</A>,"
echo -n "<A HREF=indexl.html>manl</A>,"
echo -n "<A HREF=whatis.html>whatis</A>]".
echo "</CENTER>"
echo "<H1>Nemo Reference Manual($sec)</H1>"
echo "Created on `hostname`: `date` <P>"

#echo "<DIR COMPACT>"
# foreach file (`ls man/$cat`)
#         echo "<li><a href=man/$cat/$file>$file</a>" 
# end
# echo "</DIR></BODY>"


if (0) then

echo "Apologies for the formatting bug"
echo "See also the alphabatized <A HREF=whatis.html>whatis</A> pages."

echo "<PRE>"
# ok for sunos
# (cd man_html; ls *.$sec.html | awk -F. '{a=$1"</a>";printf ("<a href=man_html/%s>%-20s\n",$0,a)}' | pr -s" " -l1 -t -5 -w200)
(cd html; ls *.$sec.html | awk -F. '{a=$1"</a>";printf ("<a href=%s>%s\n",$0,a)}' | pr -s"" -t -5 -w512)
echo "</PRE>"

else

echo "<CENTER>"
echo "<TABLE BORDER>"

pushd html > /dev/null
ls *.$sec.html | awk -F. '{print $1}' | pr -t --columns=5 --width=200 |\
  awk '{print "<tr>";for(i=1; i<=5; i++) printf("<td width=20%%><a href=%s'.$sec.html'>%s</a></td>\n",$i,$i); print "</tr>"}'
popd > /dev/null

echo "</TABLE>"
echo "</CENTER>"


endif



if (0) then
echo "<hr>"
echo "<H2> <A NAME=raw> Raw manual pages </H2>"
echo "Note: These are the raw manual 'cat' pages, there has been"
echo "no html conversion done to them yet."
echo "If you want to print them, save them, and edit them by"
echo "removing the _^H (underscore control-H) pairs."

echo "<PRE>"
ls man/$cat | awk -F. '{a=$1"</a>";printf ("<a href=man/'$cat'/%s>%-20s\n",$0,a)}' | pr -s" " -l1 -t -5 -w200
echo "</PRE>"

endif

echo "</BODY></HTML>"
