#! /bin/csh
#
#   nemo_start.csh:
#
#   Do not edit this file, it has been generated by configure
#
#   source this file to start NEMO; this file has some commented lines, 
#   which you can place in your personal 
#            ~/.nemo_local.csh 
#   or site installation
#            $NEMO/nemo_local.csh
#   
#   CSH users can place this in their ~/.cshrc file


#                                       Things via configure
setenv NEMO          /home/teuben/NEMO/redo/deb_packages/astronemo_4.2_amd64/opt/nemo_4.2
setenv NEMOHOST      x86_64-unknown-linux-gnu

#  				        Basic derived environment variables
setenv NEMOLIB     $NEMO/lib
setenv NEMOBIN     $NEMO/bin
setenv NEMOOBJ     $NEMO/obj
setenv NEMODOC     $NEMO/man/doc
setenv NEMODAT     $NEMO/data
setenv NEMOINC     $NEMO/inc
setenv NEMOSRC     $NEMO/src
setenv BTRPATH   .:$NEMO/obj/bodytrans
setenv POTPATH   .:$NEMO/obj/potential:$NEMO/obj/acc
setenv ACCPATH   .:$NEMO/obj/potential:$NEMO/obj/acc
setenv MANIPPATH .:$NEMO/obj/manip:$NEMO/usr/dehnen/falcON/manip
setenv NEMOVER   `cat $NEMO/VERSION`
setenv NEMOSYS   `uname -s`
setenv NEMOSITE  `hostname`

setenv YAPP          /xs
setenv PGPLOT_DIR    $NEMOLIB

#   MANPATH isn't so standard as you may think....
#	Ultrix doesn't handle MANPATH
#	IRIX is also particular about MANPATH
#       Linux needs to have their stuff added back in if none present
if ($?MANPATH == 0) then
 if (-e /etc/man.config) then
   # this works on linux redhat and mandrake....
   set _mandirs=(`grep -w ^MANPATH /etc/man.config | awk '{print $2}'`)
 else
   # try something else 'sensible'
   set _mandirs=(/usr/man /usr/share/man /usr/local/man /local/man /opt/man /opt/SUNWspro/man /usr/openwin/man)
 endif
 setenv MANPATH $NEMO/man
 foreach _mandir ($_mandirs)
   if (-e $_mandir) then
      setenv MANPATH ${MANPATH}:$_mandir
   endif
 end
else
 echo $MANPATH | grep -s $NEMO/man  >& /dev/null
 if ($status) setenv MANPATH $NEMO/man:$MANPATH
endif

# setenv MANPATH ${MANPATH}:${NEMO}/usr/dehnen/falcON/man  - manually copied into $NEMO/man


# Set various 'external' things we sometimes need, but only if not set

#if ($?NUMRECLIB == 0)  setenv NUMRECLIB $NEMOLIB/libnumrec.a
#if ($?GRAVSIM == 0)    setenv GRAVSIM $NEMO/usr/mbellon/gravsim
#if ($?PLPLOT_LIB == 0) setenv PLPLOT_LIB $NEMOLIB

# some useful (?) aliases

#alias keys "ls *.def"
#if (-e $NEMOBIN/miriad) alias nemo "miriad -b $NEMOBIN -p $NEMODOC -d ."
#alias motd 'more $NEMO/etc/motd'
#alias lmake 'make -f $NEMOLIB/Makefile.lib'
#alias omake 'make -f $NEMOLIB/Makefile.obj'
#alias bake  'make -f $NEMOLIB/Makefile.lib'
#alias Test  'make -f Testfile'
#alias makedefs 'make -f $NEMOLIB/makedefs makedefs_help'


# Required dummy defaults that should be overriden in NEMORC.local
# setenv YAPPLIB $YAPP_NULL



#  Set your default YAPPLIB, the current YAPP_NULL will do nothing.
#  most likely you want to make it $YAPP_PGPLOT or so, but in most of
#  those cases you will need to tailor various path elements.


# the next two are actually not really needed, derived from PGPLOT_DIR
# setenv PGPLOT_LIB  $PGPLOT_DIR
# setenv PGPLOT_FONT $PGPLOT_DIR/grfont.dat

# you can optionally uncomment and set some of the following PGPLOT variables
# see also "man 5 yapp" for more info
#setenv PGPLOT_BACKGROUND  0     # 0=black in /xs
#setenv PGPLOT_FOREGROUND  1     # 1=white in /xs
#setenv PGPLOT_BACKGROUND  white  # reverse option for /gif
#setenv PGPLOT_FOREGROUND  black  # reverse option for /gif
#setenv PGPLOT_GIF_WIDTH   512
#setenv PGPLOT_GIF_HEIGHT  512
#setenv PGPLOT_PS_WIDTH     7800
#setenv PGPLOT_PS_HEIGHT   10500
#setenv PGPLOT_PS_HOFFSET    350
#setenv PGPLOT_PS_VOFFSET    250


#  If you use the VoGL library for xyzview, this is the only reasonable default
setenv VDEVICE X11

#  tabpp needs this
#setenv $PP_DIR  /somewhere/pp_dir


#  Particularly if you use shared libraries (e.g. pgplot in $NEMOLIB) you
#  may need to change LD_LIBRARY_PATH;
#  Change 0 -> 1 if you need this

if (1) then

  if ($?LD_LIBRARY_PATH) then
    setenv LD_LIBRARY_PATH ${NEMOLIB}:${NEMO}/opt/lib:${LD_LIBRARY_PATH}
  else
    setenv LD_LIBRARY_PATH ${NEMOLIB}:${NEMO}/opt/lib
  endif
  if ("$PGPLOT_DIR" != "$NEMOLIB") then
    setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:$PGPLOT_DIR
  endif

  # Hack for Mac, i guess it won't hurt on linux
  # on Mac here's another problem:  might need to use DYLD_INSERT_LIBRARIES
  # similar to the LD_PRELOAD on linux.  This might be needed for
  # libunsio.{dylib,so} is a case where this was needed
  if ($?DYLD_LIBRARY_PATH) then
    setenv DYLD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${DYLD_LIBRARY_PATH}
  else
    setenv DYLD_LIBRARY_PATH $LD_LIBRARY_PATH
  endif
  
endif

# for unsio 1.0.0: $NEMO/py/modules
if (1) then
  if ($?PYTHONPATH) then
    setenv PYTHONPATH $NEMO/py/modules:$PYTHONPATH
  else
    setenv PYTHONPATH $NEMO/py/modules
  endif
endif


#                                                            optional ZENO
if (-e $NEMO/usr/zeno/ZENORC)  source $NEMO/usr/zeno/ZENORC

#                                                            optional local and personal NEMO things
if (-e $NEMO/nemo_local.csh)   source $NEMO/nemo_local.csh
if (-e $HOME/.nemo_local.csh)  source $HOME/.nemo_local.csh


set path = ( $NEMOBIN $NEMO/opt/bin $path )
rehash

# falcON
setenv FALCON $NEMO/usr/dehnen/falcON
source $FALCON/falcON_start.csh


