#! /bin/csh
#
#   nemo_start.sh:
#
#   Do not edit this file, it has been generated by configure
#
#   source this file to start NEMO; the csh counterpart has some commented 
#   lines, which you can place in your personal 
#            ~/.nemo_local.sh 
#   or site installation
#            $NEMO/nemo_local.sh
#   
#   BASH interactive shell uses ~/.bashrc     
#        login shell       uses ~/.bash_login (or .bash_profile)
#   Note Linux uses the interactive shell, Mac uses the login shell
#
#                                       Things via configure
export          NEMO=/home/teuben/NEMO/redo/deb_packages/astronemo_4.2_amd64/opt/nemo_4.2
export      NEMOHOST=x86_64-unknown-linux-gnu

#  				        Basic derived environment variables
export NEMOLIB=$NEMO/lib
export NEMOBIN=$NEMO/bin
export NEMOOBJ=$NEMO/obj
export NEMODOC=$NEMO/man/doc
export NEMODAT=$NEMO/data
export NEMOINC=$NEMO/inc
export NEMOSRC=$NEMO/src
export BTRPATH=.:$NEMO/obj/bodytrans
export POTPATH=.:$NEMO/obj/potential:$NEMO/obj/acc
export ACCPATH=.:$NEMO/obj/potential:$NEMO/obj/acc
export MANIPPATH=.:$NEMO/obj/manip:$NEMO/usr/dehnen/falcON/manip
export NEMOVER=`cat $NEMO/VERSION`
export NEMOSYS=`uname -s`
export NEMOSITE=`hostname`

export YAPP=/xs
export PGPLOT_DIR=$NEMOLIB


if [ -z "$MANPATH" ]; then
  export MANPATH=$NEMO/man
else
  export MANPATH=$NEMO/man:$MANPATH
fi
# $NEMO/usr/dehnen/falcON/ was manually merged into $NEMO/man


#  If you use the VoGL library for xyzview, this is the only reasonable default
export VDEVICE=X11

if [ 1 ]; then
  if [ -z "$LD_LIBRARY_PATH" ]; then
    export LD_LIBRARY_PATH=$NEMOLIB:$NEMO/opt/lib
  else
    export LD_LIBRARY_PATH=$NEMOLIB:$NEMO/opt/lib:$LD_LIBRARY_PATH
  fi
  # if ("$PGPLOT_DIR" != "$NEMOLIB") then

  # Hack for Mac, i guess it won't hurt on linux
  # on Mac here's another problem:  might need to use DYLD_INSERT_LIBRARIES
  # similar to the LD_PRELOAD on linux.  This might be needed for
  # libunsio.{dylib,so} is a case where this was needed
  if [ -z "$DYLD_LIBRARY_PATH" ]; then
    export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH:$NEMO/opt/lib
  else
    export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH:$NEMO/opt/lib:$DYLD_LIBRARY_PATH
  fi
fi

# for unsio 1.0.0: $NEMO/py/modules
if [ -z "$PYTHONPATH" ]; then
  export PYTHONPATH=$NEMO/py/modules
else
  export PYTHONPATH=$NEMO/py/modules:$PYTHONPATH
fi


# ZENO has no bash support yet
test -f $NEMO/usr/zeno/ZENORC   &&     echo "No ZENO support for bash yet"

test -f $NEMO/nemo_local.sh     &&     source $NEMO/nemo_local.sh
test -f $HOME/.nemo_local.sh    &&     source $HOME/.nemo_local.sh

# optional dot check?
export PATH=$NEMOBIN:$NEMO/opt/bin:$PATH

# falcON 
export FALCON=$NEMO/usr/dehnen/falcON
source $FALCON/falcON_start.sh
